require 'json'
require 'stringio'
require 'logger'
require 'predicsis_ml_sdk/version'
require 'predicsis_ml_sdk/configuration'
require 'predicsis_ml_sdk/core_ext'
require 'predicsis_ml_sdk/errors'
require 'predicsis_ml_sdk/util'

module PredicsisMlSdk
  module_function
  attr_accessor :config

  def config
    @config ||= Configuration.new
  end

  def configure
    yield config
  end

  def logger
    config.logger
  end

  autoload :AccessToken, 'predicsis_ml_sdk/access_token'
  autoload :Upload, 'predicsis_ml_sdk/upload'
  autoload :DataFile, 'predicsis_ml_sdk/data_file'
  autoload :Dataset, 'predicsis_ml_sdk/dataset'
  autoload :Dictionary, 'predicsis_ml_sdk/dictionary'
  autoload :Job, 'predicsis_ml_sdk/job'
  autoload :JobStuff, 'predicsis_ml_sdk/job_stuff'
  autoload :ModalitiesSet, 'predicsis_ml_sdk/modalities_set'
  autoload :Model, 'predicsis_ml_sdk/model'
  autoload :PreparationRulesSet, 'predicsis_ml_sdk/preparation_rules_set'
  autoload :Report, 'predicsis_ml_sdk/report'
  autoload :Source, 'predicsis_ml_sdk/source'
  autoload :Variable, 'predicsis_ml_sdk/variable'
  autoload :Requests, 'predicsis_ml_sdk/requests'
end
