module PredicsisMlSdk
  class AccessToken
    include Util

    attr_accessor :id

    def self.create(params = {}, token = bearer_token)
      data = Requests.post_token(token, params)
      new(data['id'], token).tap do |access_token|
        access_token.define_attributes(data)
      end
    end

    def self.all(token = bearer_token)
      data = Requests.get_tokens(token)
      data.each_with_object([]) do |e, a|
        a << new(e['id'], token).tap do |resource|
          resource.send(:define_attributes, e)
        end
      end
    end

    def self.get(id, token = bearer_token)
      new(id, token).get
    end

    def self.delete(id, token = bearer_token)
      new(id, token).delete
    end

    def initialize(id, token = bearer_token)
      @token = token
      @id = id
    end

    def get
      data = Requests.get_token(token, id)
      define_attributes(data)
      self
    end

    def delete
      Requests.delete_token(token, id)
      self
    end
  end
end
