module PredicsisMlSdk
  class Report
    include Util
    include JobStuff

    attr_accessor :id

    def self.create(params = {}, token = bearer_token)
      data = Requests.post_report(token, params)
      new(data['id'], token).tap do |report|
        report.define_attributes(data)
      end
    end

    def self.all(token = bearer_token)
      data = Requests.get_reports(token)
      data.each_with_object([]) do |e, a|
        a << Report.new(e['id'], token).tap do |resource|
          resource.send(:define_attributes, e)
        end
      end
    end

    def self.get(id, token = bearer_token)
      new(id, token).get
    end

    def self.update(id, params = {}, token = bearer_token)
      new(id, token).update(params)
    end

    def self.delete(id, token = bearer_token)
      new(id, token).delete
    end

    def initialize(id, token = bearer_token)
      @token = token
      @id = id
    end

    def get
      data = Requests.get_report(token, id)
      define_attributes(data)
      self
    end

    def update(params = {})
      data = Requests.patch_report(token, id, params)
      define_attributes(data)
      self
    end

    def delete
      Requests.delete_report(token, id)
      self
    end
  end
end
