module Util
  attr_reader :token

  def self.included(base)
    base.extend ClassMethods
  end

  def with_captured_console
    old_stdout = $stdout
    old_stderr = $stderr
    $stdout = $stderr = StringIO.new('', 'w')
    yield
    $stdout.string
  ensure
    $stdout = old_stdout
    $stderr = old_stderr
  end

  def define_attributes(data)
    data.each do |k, v|
      if k.eql?('error')
        self.class.class_eval { attr_accessor "#{k}" }
        send("#{k}=", v)
      elsif v.is_a?(Hash)
        v.delete('id')
        define_attributes(v)
      else
        self.class.class_eval { attr_accessor "#{k}" }
        send("#{k}=", v)
      end
    end
  end

  def bearer_token
    PredicsisMlSdk.config.bearer_token
  end

  module ClassMethods
    def bearer_token
      PredicsisMlSdk.config.bearer_token
    end
  end
end
