module PredicsisMlSdk
  class Variable
    include Util
    attr_accessor :dictionary_id, :id

    def self.get(dictionary_id, id, token = bearer_token)
      new(dictionary_id, id, token).get
    end

    def self.update(dictionary_id, id, params = {}, token = bearer_token)
      new(dictionary_id, id, token).update(params)
    end

    def self.all(dictionary_id, token = bearer_token)
      data = Requests.get_variables(token, dictionary_id)
      data.each_with_object([]) do |e, a|
        a << new(dictionary_id, e['id'], token).tap do |variable|
          variable.send(:define_attributes, e)
        end
      end
    end

    def initialize(dictionary_id, id, token = bearer_token)
      @dictionary_id = dictionary_id
      @id = id
      @token = token
    end

    def get
      data = Requests.get_variable(token, id, dictionary_id)
      define_attributes(data)
      self
    end

    def update(params = {})
      data = Requests.patch_variable(token, id, dictionary_id, params)
      define_attributes(data)
      self
    end
  end
end
